﻿Enumeration
  
  #Library
  
  #Window
  
  #Mon
  
EndEnumeration

DataSection
  
    
  BaSSDLL: 
    IncludeBinary "bass.dll"                  
  EndBaSSDLL:

  ;PSGDLL: 
  ;  IncludeBinary "segapsg.dll"                  
  ;EndPSGDLL: 

  
EndDataSection

XIncludeFile "DllFromMememory.pbi"

#BASS_DEVICE_8BITS      = 1
#BASS_DEVICE_MONO       = 2
#BASS_DEVICE_STEREO     = $8000
#BASS_STREAM_AUTOFREE   = $40000
#BASS_STREAMPROC_END	  = $80000000

;PrototypeC.i Protosegapsg_init(base_clock.i, rate.i, neg.i)
;Global segapsg_init.Protosegapsg_init

;PrototypeC Protosegapsg_write_stereo(*chip, datavalue.l)
;Global segapsg_write_stereo.Protosegapsg_write_stereo

;PrototypeC Protosegapsg_write_register(*chip, datavalue.l)
;Global segapsg_write_register.Protosegapsg_write_register

;PrototypeC Protosegapsg_render(*chip, *buffer, samples.i, add.i)
;Global segapsg_render.Protosegapsg_render

;PrototypeC.s Protosegapsg_about()
;Global segapsg_about.Protosegapsg_about

Prototype.l ProtoBASS_Init(device.l,freq.l,flags.l,win.l,*dsguid)
Global BASS_Init.ProtoBASS_Init

Prototype.l ProtoBASS_StreamCreate(freq.l,chans.l,flags.l,*proc,*user)
Global BASS_StreamCreate.ProtoBASS_StreamCreate

Prototype.l ProtoBASS_ChannelPlay(handle.l,restart.l)
Global BASS_ChannelPlay.ProtoBASS_ChannelPlay


;PSGhdll = LoadLibraryEx(?PSGDLL, ?EndPSGDLL, 72768)
BSShdll = LoadLibraryEx(?BaSSDLL, ?EndBaSSDLL, 131772)

If BSShdll ;And PSGhdll
  
  ;segapsg_init = GetProcAddressEx(PSGhdll, "segapsg_init")
  ;segapsg_write_stereo = GetProcAddressEx(PSGhdll, "segapsg_write_stereo")
  ;segapsg_write_register = GetProcAddressEx(PSGhdll, "segapsg_write_register")
  ;segapsg_render = GetProcAddressEx(PSGhdll, "segapsg_render")
  ;segapsg_about = GetProcAddressEx(PSGhdll, "segapsg_about")
  
  BASS_Init = GetProcAddressEx(BSShdll, "BASS_Init")
  BASS_StreamCreate = GetProcAddressEx(BSShdll, "BASS_StreamCreate")
  BASS_ChannelPlay = GetProcAddressEx(BSShdll, "BASS_ChannelPlay")  
  
EndIf

;Global cpu



;User stream writing callback function.
;DWORD CALLBACK StreamProc(
;    HSTREAM handle,
;    void *buffer,
;    DWORD length,
;    void *user
;);
;Parameters
;handle	The stream that needs writing.
;buffer	Pointer To the buffer To write the sample Data in. The Data should be As follows: 8-bit samples are unsigned, 16-bit samples are signed, 32-bit floating-point samples range from -1 To +1.
;length	The maximum number of bytes To write.
;user	The user instance Data given when BASS_StreamCreate was called.
;Return value
;The number of bytes written by the function, optionally using the BASS_STREAMPROC_END flag To signify that the End of the stream is reached.
;http://www.un4seen.com/doc/#bass/STREAMPROC.html

Global Dim volumeTable.f(63)
;{
tik = 0 : volumeTable(tik) = 0.25
tik + 1 : volumeTable(tik) = 0.2442
tik + 1 : volumeTable(tik) = 0.1940
tik + 1 : volumeTable(tik) = 0.1541
tik + 1 : volumeTable(tik) = 0.1224
tik + 1 : volumeTable(tik) = 0.0972
tik + 1 : volumeTable(tik) = 0.0772
tik + 1 : volumeTable(tik) = 0.0613
tik + 1 : volumeTable(tik) = 0.0487
tik + 1 : volumeTable(tik) = 0.0386
tik + 1 : volumeTable(tik) = 0.0307 ;10
tik + 1 : volumeTable(tik) = 0.0244
tik + 1 : volumeTable(tik) = 0.0193
tik + 1 : volumeTable(tik) = 0.0154
tik + 1 : volumeTable(tik) = 0.0122
tik + 1 : volumeTable(tik) = 0      ;15


tik + 1 : volumeTable(tik) = -0.25
tik + 1 : volumeTable(tik) = -0.2442
tik + 1 : volumeTable(tik) = -0.1940
tik + 1 : volumeTable(tik) = -0.1541
tik + 1 : volumeTable(tik) = -0.1224
tik + 1 : volumeTable(tik) = -0.0972
tik + 1 : volumeTable(tik) = -0.0772
tik + 1 : volumeTable(tik) = -0.0613
tik + 1 : volumeTable(tik) = -0.0487
tik + 1 : volumeTable(tik) = -0.0386
tik + 1 : volumeTable(tik) = -0.0307
tik + 1 : volumeTable(tik) = -0.0244
tik + 1 : volumeTable(tik) = -0.0193
tik + 1 : volumeTable(tik) = -0.0154
tik + 1 : volumeTable(tik) = -0.0122
tik + 1 : volumeTable(tik) = 0       ;31


tik + 1 : volumeTable(tik) = 0.25
tik + 1 : volumeTable(tik) = 0.2442
tik + 1 : volumeTable(tik) = 0.1940
tik + 1 : volumeTable(tik) = 0.1541
tik + 1 : volumeTable(tik) = 0.1224
tik + 1 : volumeTable(tik) = 0.0972
tik + 1 : volumeTable(tik) = 0.0772
tik + 1 : volumeTable(tik) = 0.0613
tik + 1 : volumeTable(tik) = 0.0487
tik + 1 : volumeTable(tik) = 0.0386
tik + 1 : volumeTable(tik) = 0.0307
tik + 1 : volumeTable(tik) = 0.0244
tik + 1 : volumeTable(tik) = 0.0193
tik + 1 : volumeTable(tik) = 0.0154
tik + 1 : volumeTable(tik) = 0.0122
tik + 1 : volumeTable(tik) = 0.0

tik + 16
;0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;}

Macro SetBit(Var, Bit)
  Var | (Bit)
EndMacro
 
Macro ClearBit(Var, Bit) 
  Var & (~(Bit))
EndMacro

Macro TestBit(Var, Bit)
  Bool(Var & (Bit))
EndMacro
 
Macro NumToBit(Num)
  (1<<(Num))
EndMacro

Macro GetBits(Var, StartPos, EndPos)
  ((Var>>(StartPos))&(NumToBit((EndPos)-(StartPos)+1)-1))
EndMacro

     Global volA.i, volB.i, volC.i, volD.i
     Global divA.i, divB.i, divC.i, divD.i
     Global cntA.i, cntB.i, cntC.i, cntD.i
     Global outA.f, outB.f, outC.f, outD.f
     Global noiseLFSR.i, noiseTap.i, latchedChan.i
     Global ticksPerSample.f
     Global ticksCount.f    
     Global Dim ByteArray.f(0)
     Global latchedVolume
     
     Global Quit
     
Procedure clock(f)
                      ;16 probably bit, but .f is 32 i think, not 16
  ticksPerSample = f / 32 / 44100;
  
EndProcedure

Procedure reset()
  
        volA = 15;
        volB = 15;
        volC = 15;
        volD = 15;
        outA = 0;
        outB = 0;
        outC = 0;
        outD = 0;
        latchedChan = 0;
        latchedVolume = #False;
        noiseLFSR = $8000 ;0x8000; ??????????????
        ticksCount = ticksPerSample 
  
EndProcedure

Procedure SN76489()
  
  clock(3500000) ; frequency for cpu. it need 3579545 NTSC and 3546893 for Pal
  reset()
  
EndProcedure

Procedure.i getDivByNumber(chan.i) ;chan:uint??????
  
  ;switch(chan) - select???
  Select chan
    Case 0
      rec = divA 
    Case 1   
      rec = divB
    Case 2
      rec = divC
    Case 3
      rec = divD
  EndSelect
  
  ProcedureReturn rec
  
EndProcedure

Procedure setDivByNumber(chan.i, div.i)
  
  Select chan
    Case 0
      divA = div
    Case 1
      divB = div 
    Case 2
      divC = div
    Case 3
      divD = div
  EndSelect   
  
EndProcedure

Procedure.i getVolByNumber(chan.i)
  
  Select chan
    Case 0
      ProcedureReturn volA 
    Case 1
      ProcedureReturn volB  
    Case 2
      ProcedureReturn volC
    Case 3
      ProcedureReturn volD
    Default
      ProcedureReturn 0
  EndSelect
  
EndProcedure

Procedure setVolByNumber(chan.i, vol.i)
  
  Select chan
    Case 0
      volA = vol
    Case 1
      volB = vol
    Case 2
      volC = vol
    Case 3
      volD = vol
  EndSelect
  
EndProcedure

Procedure write(val.i)
  
  If TestBit(val, NumToBit(7))
    chan = GetBits(val, 5, 6) 
    
    ;cdiv=(getDivByNumber(chan)&0xfff0)|(val&15);    
    cdiv = GetBits(getDivByNumber(chan), 0, 5) << 4 + GetBits(val, 0, 3)
    
    latchedChan = chan
    
    ;latchedVolume = val&16?true:false
    latchedVolume = TestBit(val, NumToBit(4))
  Else
    chan = latchedChan 
    ;cdiv = (getDivByNumber(chan)&15)|((val&63)<<4)
    cdiv = GetBits(val, 0, 5) << 4 + GetBits(getDivByNumber(chan), 0, 3)
  EndIf
  
  If latchedVolume
    ;setVolByNumber(chan,(getVolByNumber(chan)&16)|(val&15));
    tmp = TestBit(getVolByNumber(chan), NumToBit(4))
    tmp << 4
    tmp + GetBits(val, 0, 3)
    setVolByNumber(chan, tmp)
    
  Else
    setDivByNumber(chan, cdiv)
    If chan = 3
      ;noiseTap = ((cdiv>>2)&1)?9:1; ???????????????      
      tmp = cdiv
      tmp >> 2      
      If tmp & 1
        noiseTap = 9
      Else
        noiseTap = 1
      EndIf

      noiseLFSR = $8000;
    EndIf
  EndIf
    
  
EndProcedure

Procedure.l PREsegapsg_render(handle.i, *buffer, length.l, *user)
  
  out.f
  
  For i = 0 To length
    
    While(ticksCount > 0) ;
      
      ;С- = 50;	C = с - 50;
      cntA - 1
      If cntA < 0
        If divA > 1
          ;volA^=16
          volA!16
          ;outA = Number(volumeTable(volA)); 
          outA = volumeTable(volA)
        EndIf
        cntA = divA        
      EndIf
      
      cntB - 1;
      If cntB < 0 
        If divB > 1
          volB!16
          outB = volumeTable(volB);
        EndIf
        cntB = divB
      EndIf
      
      cntC - 1;
      If cntC < 0 
        If divC > 1 
          volC!16
          outC = volumeTable(volC);
        EndIf
        cntC = divC;
      EndIf
      
      cntD - 1
      If cntD < 0
        cdiv = divD&3; 
        ;If(cdiv<3) cntD=0x10<<cdiv; else cntD=divC<<1;
        If cdiv < 3 
          cntD = $10 
          cntD << cdiv 
        Else 
          cntD = divC
          cntD << 1 
        EndIf
        
        If noiseTap = 9 
          tap = noiseLFSR & noiseTap
          ;tap^=tap>>8; 
          tap!tap>>8
          tap!tap>>4
          tap!tap>>2
          tap!tap>>1
          tap&1
        Else
          tap = noiseLFSR & 1
        EndIf
        
        noiseLFSR = (noiseLFSR>>1)|(tap<<15)
        
        ;volD = (volD&15)|((noiseLFSR&1^1)<<4)    ;??????????????????    
        tmp = noiseLFSR
        tmp&1
        tmp!1
        tmp << 4        
        volD = volD&15 | tmp        
        
        outD = volumeTable(volD)
        
      EndIf

      ticksCount - 1
      
    Wend
    
    ticksCount + ticksPerSample
    out = outA + outB + outC + outD ; + each other? not get lowers or bigest from 4 values?

    PokeF(*buffer+i, out)
    
  Next
  
  ProcedureReturn #True
  
EndProcedure
  


Procedure Mon(*Value)
  
  Repeat
    SetGadgetItemText(#Mon, 0, Str(volA), 1)
    SetGadgetItemText(#Mon, 1, Str(volB), 1)
    SetGadgetItemText(#Mon, 2, Str(volC), 1)
    SetGadgetItemText(#Mon, 3, Str(volD), 1)
    
    SetGadgetItemText(#Mon, 4, Str(outA), 1)
    SetGadgetItemText(#Mon, 5, Str(outB), 1)
    SetGadgetItemText(#Mon, 6, Str(outC), 1)
    SetGadgetItemText(#Mon, 7, Str(outD), 1)
    
    
    SetGadgetItemText(#Mon, 8, Str(latchedChan), 1)
    SetGadgetItemText(#Mon, 9, Str(latchedVolume), 1)
    SetGadgetItemText(#Mon, 10, Str(noiseLFSR), 1)
    SetGadgetItemText(#Mon, 11, Str(ticksCount), 1)
    
    SetGadgetItemText(#Mon, 12, Str(divA), 1)
    SetGadgetItemText(#Mon, 13, Str(divB), 1)
    SetGadgetItemText(#Mon, 14, Str(divC), 1)
    SetGadgetItemText(#Mon, 15, Str(divD), 1)
    
    Delay(1)
  Until Quit = 1
  
EndProcedure

Procedure Spam(*Value)
  
  Repeat
    
  XIncludeFile "spam.pb"

  ForEver
  
EndProcedure

  Global monthr

  handle = OpenWindow(#Window, 0, 0, 222, 400, "ButtonGadgets", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If handle
    
    ListIconGadget(#Mon, 5, 5, 200, 380, "stats", 100)
    AddGadgetColumn(#Mon, 1, "val", 50)
    AddGadgetItem(#Mon, -1, "volA")
    AddGadgetItem(#Mon, -1, "volB")
    AddGadgetItem(#Mon, -1, "volC")
    AddGadgetItem(#Mon, -1, "volD")
    AddGadgetItem(#Mon, -1, "outA")
    AddGadgetItem(#Mon, -1, "outB")
    AddGadgetItem(#Mon, -1, "outC")
    AddGadgetItem(#Mon, -1, "outD")
    AddGadgetItem(#Mon, -1, "latchedChan")
    AddGadgetItem(#Mon, -1, "latchedVolume")
    AddGadgetItem(#Mon, -1, "noiseLFSR")
    AddGadgetItem(#Mon, -1, "ticksCount")
    
    AddGadgetItem(#Mon, -1, "divA")
    AddGadgetItem(#Mon, -1, "divB")
    AddGadgetItem(#Mon, -1, "divC")
    AddGadgetItem(#Mon, -1, "divD")
    
    ;monitoring thread. for save cpu will need turn off
    monthr = CreateThread(@Mon(), 154)
        
    
    ;                         ;#BASS_DEVICE_MONO
                  ;44100      ;#BASS_DEVICE_STEREO
    BASS_Init(-1, 44100, #BASS_DEVICE_MONO, handle, #Null)
    SN76489()
                                    ;mono, 2 stereo
    sound = BASS_StreamCreate(44100, 1, #BASS_STREAM_AUTOFREE, @PREsegapsg_render(), 0)

    BASS_ChannelPlay(sound, 0)    
    
    CreateThread(@Spam(), 154) ; send "music" into "engine"
    
Repeat
    
      Event = WaitWindowEvent()
    
      Select Event
       
        Case #PB_Event_CloseWindow
          Quit = 1
          Repeat 
            If IsThread(monthr)
              KillThread(monthr)
            EndIf
            Delay(10)            
          Until IsThread(monthr) = 0
         
      EndSelect

    Until Quit = 1

  EndIf

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 509
; FirstLine = 354
; Folding = -Pk
; EnableUnicode
; EnableThread
; EnableXP